package com.atlassian.confluence.rpc;

import com.atlassian.confluence.setup.settings.SettingsManager;
import com.atlassian.confluence.setup.settings.Settings;
import com.atlassian.confluence.setup.settings.SpaceSettings;
import com.atlassian.confluence.setup.settings.PluginSettings;

import java.io.Serializable;

/**
 * A simple settings manager for use in tests that keeps settings in memory and has no dependencies.
 */
public class MemorySettingsManager implements SettingsManager
{
    private Settings settings = new Settings();

    public Settings getGlobalSettings()
    {
        return settings;
    }

    public void updateGlobalSettings(Settings settings)
    {
        this.settings = settings;
    }

    public SpaceSettings getSpaceSettings(String spaceKey)
    {
        throw new UnsupportedOperationException();
    }

    public void updateSpaceSettings(SpaceSettings spaceSettings)
    {
        throw new UnsupportedOperationException();
    }

    public Serializable getPluginSettings(String pluginKey)
    {
        throw new UnsupportedOperationException();
    }

    public void updatePluginSettings(String pluginKey, Serializable pluginSettings)
    {
        throw new UnsupportedOperationException();
    }
}
